/*
**                   tc-GUI v1.2 - August 02, 2006
**
**   This program is a GUI frontend for the commandline programs cfr2tc,
**   tc2cfr, and tcConv.
**   
**   Copyright (C) 2005-2006 Kevin Stone
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Threading;
using System.Resources;

namespace tc_GUI
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		bool cfr_running = false;
		bool tc_running = false;
		bool tcc_running = false;
		string cfr_path = "";
		string tc_path = "";
		string tcc_path = "";
		ProcessStartInfo psInfo_cfr = new ProcessStartInfo();
		ProcessStartInfo psInfo_tc = new ProcessStartInfo();
		ProcessStartInfo psInfo_tcc = new ProcessStartInfo();

		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabPage1;
		private System.Windows.Forms.TabPage tabPage2;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.Button cfr_b1;
		private System.Windows.Forms.TextBox cfr_tb1;
		private System.Windows.Forms.Label cfr_l1;
		private System.Windows.Forms.Label cfr_l2;
		private System.Windows.Forms.TextBox cfr_tb2;
		private System.Windows.Forms.Button cfr_b2;
		private System.Windows.Forms.Label cfr_l3;
		private System.Windows.Forms.TextBox cfr_tb3;
		private System.Windows.Forms.Button cfr_b3;
		private System.Windows.Forms.Button cfr_b4;
		private System.Windows.Forms.Label tc_l3;
		private System.Windows.Forms.TextBox tc_tb3;
		private System.Windows.Forms.Button tc_b3;
		private System.Windows.Forms.Label tc_l2;
		private System.Windows.Forms.TextBox tc_tb2;
		private System.Windows.Forms.Button tc_b2;
		private System.Windows.Forms.Label tc_l1;
		private System.Windows.Forms.TextBox tc_tb1;
		private System.Windows.Forms.Button tc_b1;
		private System.Windows.Forms.Label tc_l4;
		private System.Windows.Forms.Button tc_b4;
		private System.Windows.Forms.TextBox tc_tb4;
		private System.Windows.Forms.TabPage tabPage3;
		private System.Windows.Forms.Label ep_lb2;
		private System.Windows.Forms.Label ep_lb3;
		private System.Windows.Forms.TextBox ep_tb1;
		private System.Windows.Forms.Button ep_b1;
		private System.Windows.Forms.TextBox ep_tb2;
		private System.Windows.Forms.Button ep_b2;
		private System.Windows.Forms.Label ep_lb1;
		private System.Windows.Forms.TabPage tabPage4;
		private System.Windows.Forms.Label ep_lb4;
		private System.Windows.Forms.TextBox ep_tb3;
		private System.Windows.Forms.Button ep_b3;
		private System.Windows.Forms.Label tcc_l2;
		private System.Windows.Forms.TextBox tcc_tb2;
		private System.Windows.Forms.Button tcc_b2;
		private System.Windows.Forms.Label tcc_l1;
		private System.Windows.Forms.TextBox tcc_tb1;
		private System.Windows.Forms.Button tcc_b1;
		private System.Windows.Forms.Label tcc_lb3;
		private System.Windows.Forms.TextBox tcc_tb4;
		private System.Windows.Forms.Label tcc_lb5;
		private System.Windows.Forms.TextBox tcc_tb5;
		private System.Windows.Forms.Label tcc_lb6;
		private System.Windows.Forms.TextBox tcc_tb3;
		private System.Windows.Forms.Label tcc_lb4;
		private System.Windows.Forms.ComboBox tcc_dl1;
		private System.Windows.Forms.Button tcc_b3;
		private System.Windows.Forms.Label cfr_l5;
		private System.Windows.Forms.ComboBox cfr_dl1;
		private System.Windows.Forms.CheckBox tc_cb1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage1 = new System.Windows.Forms.TabPage();
			this.cfr_l5 = new System.Windows.Forms.Label();
			this.cfr_dl1 = new System.Windows.Forms.ComboBox();
			this.cfr_b4 = new System.Windows.Forms.Button();
			this.cfr_l3 = new System.Windows.Forms.Label();
			this.cfr_tb3 = new System.Windows.Forms.TextBox();
			this.cfr_b3 = new System.Windows.Forms.Button();
			this.cfr_l2 = new System.Windows.Forms.Label();
			this.cfr_tb2 = new System.Windows.Forms.TextBox();
			this.cfr_b2 = new System.Windows.Forms.Button();
			this.cfr_l1 = new System.Windows.Forms.Label();
			this.cfr_tb1 = new System.Windows.Forms.TextBox();
			this.cfr_b1 = new System.Windows.Forms.Button();
			this.tabPage2 = new System.Windows.Forms.TabPage();
			this.tc_tb4 = new System.Windows.Forms.TextBox();
			this.tc_l4 = new System.Windows.Forms.Label();
			this.tc_b4 = new System.Windows.Forms.Button();
			this.tc_l3 = new System.Windows.Forms.Label();
			this.tc_tb3 = new System.Windows.Forms.TextBox();
			this.tc_b3 = new System.Windows.Forms.Button();
			this.tc_l2 = new System.Windows.Forms.Label();
			this.tc_tb2 = new System.Windows.Forms.TextBox();
			this.tc_b2 = new System.Windows.Forms.Button();
			this.tc_l1 = new System.Windows.Forms.Label();
			this.tc_tb1 = new System.Windows.Forms.TextBox();
			this.tc_b1 = new System.Windows.Forms.Button();
			this.tabPage4 = new System.Windows.Forms.TabPage();
			this.tcc_b3 = new System.Windows.Forms.Button();
			this.tcc_tb3 = new System.Windows.Forms.TextBox();
			this.tcc_lb4 = new System.Windows.Forms.Label();
			this.tcc_tb5 = new System.Windows.Forms.TextBox();
			this.tcc_lb6 = new System.Windows.Forms.Label();
			this.tcc_tb4 = new System.Windows.Forms.TextBox();
			this.tcc_lb5 = new System.Windows.Forms.Label();
			this.tcc_lb3 = new System.Windows.Forms.Label();
			this.tcc_dl1 = new System.Windows.Forms.ComboBox();
			this.tcc_l2 = new System.Windows.Forms.Label();
			this.tcc_tb2 = new System.Windows.Forms.TextBox();
			this.tcc_b2 = new System.Windows.Forms.Button();
			this.tcc_l1 = new System.Windows.Forms.Label();
			this.tcc_tb1 = new System.Windows.Forms.TextBox();
			this.tcc_b1 = new System.Windows.Forms.Button();
			this.tabPage3 = new System.Windows.Forms.TabPage();
			this.ep_lb4 = new System.Windows.Forms.Label();
			this.ep_tb3 = new System.Windows.Forms.TextBox();
			this.ep_b3 = new System.Windows.Forms.Button();
			this.ep_lb1 = new System.Windows.Forms.Label();
			this.ep_lb3 = new System.Windows.Forms.Label();
			this.ep_tb2 = new System.Windows.Forms.TextBox();
			this.ep_b2 = new System.Windows.Forms.Button();
			this.ep_lb2 = new System.Windows.Forms.Label();
			this.ep_tb1 = new System.Windows.Forms.TextBox();
			this.ep_b1 = new System.Windows.Forms.Button();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.tc_cb1 = new System.Windows.Forms.CheckBox();
			this.tabControl1.SuspendLayout();
			this.tabPage1.SuspendLayout();
			this.tabPage2.SuspendLayout();
			this.tabPage4.SuspendLayout();
			this.tabPage3.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPage1);
			this.tabControl1.Controls.Add(this.tabPage2);
			this.tabControl1.Controls.Add(this.tabPage4);
			this.tabControl1.Controls.Add(this.tabPage3);
			this.tabControl1.Location = new System.Drawing.Point(0, 1);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(488, 208);
			this.tabControl1.TabIndex = 0;
			// 
			// tabPage1
			// 
			this.tabPage1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.tabPage1.Controls.Add(this.cfr_l5);
			this.tabPage1.Controls.Add(this.cfr_dl1);
			this.tabPage1.Controls.Add(this.cfr_b4);
			this.tabPage1.Controls.Add(this.cfr_l3);
			this.tabPage1.Controls.Add(this.cfr_tb3);
			this.tabPage1.Controls.Add(this.cfr_b3);
			this.tabPage1.Controls.Add(this.cfr_l2);
			this.tabPage1.Controls.Add(this.cfr_tb2);
			this.tabPage1.Controls.Add(this.cfr_b2);
			this.tabPage1.Controls.Add(this.cfr_l1);
			this.tabPage1.Controls.Add(this.cfr_tb1);
			this.tabPage1.Controls.Add(this.cfr_b1);
			this.tabPage1.Location = new System.Drawing.Point(4, 22);
			this.tabPage1.Name = "tabPage1";
			this.tabPage1.Size = new System.Drawing.Size(480, 182);
			this.tabPage1.TabIndex = 0;
			this.tabPage1.Text = "cfr2tc";
			// 
			// cfr_l5
			// 
			this.cfr_l5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cfr_l5.Location = new System.Drawing.Point(63, 148);
			this.cfr_l5.Name = "cfr_l5";
			this.cfr_l5.Size = new System.Drawing.Size(43, 16);
			this.cfr_l5.TabIndex = 15;
			this.cfr_l5.Text = "Mode:";
			// 
			// cfr_dl1
			// 
			this.cfr_dl1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cfr_dl1.Items.AddRange(new object[] {
														 "1 - v1 timecode file, avi output",
														 "2 - v2 timecode file, avi output",
														 "3 - v1 timecode file, no video output",
														 "4 - v2 timecode file, no video output",
														 "5 - v1 timecode file, avs output",
														 "6 - v2 timecode file, avs output"});
			this.cfr_dl1.Location = new System.Drawing.Point(113, 146);
			this.cfr_dl1.Name = "cfr_dl1";
			this.cfr_dl1.Size = new System.Drawing.Size(202, 21);
			this.cfr_dl1.TabIndex = 14;
			this.cfr_dl1.SelectedIndexChanged += new System.EventHandler(this.cfr_dl1_SelectedIndexChanged);
			// 
			// cfr_b4
			// 
			this.cfr_b4.Location = new System.Drawing.Point(352, 144);
			this.cfr_b4.Name = "cfr_b4";
			this.cfr_b4.Size = new System.Drawing.Size(72, 24);
			this.cfr_b4.TabIndex = 11;
			this.cfr_b4.Text = "Run";
			this.cfr_b4.Click += new System.EventHandler(this.cfr_b4_Click);
			// 
			// cfr_l3
			// 
			this.cfr_l3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cfr_l3.Location = new System.Drawing.Point(16, 104);
			this.cfr_l3.Name = "cfr_l3";
			this.cfr_l3.Size = new System.Drawing.Size(96, 16);
			this.cfr_l3.TabIndex = 8;
			this.cfr_l3.Text = "Output TC File:";
			this.cfr_l3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cfr_tb3
			// 
			this.cfr_tb3.BackColor = System.Drawing.SystemColors.Window;
			this.cfr_tb3.ForeColor = System.Drawing.SystemColors.WindowText;
			this.cfr_tb3.Location = new System.Drawing.Point(112, 102);
			this.cfr_tb3.Name = "cfr_tb3";
			this.cfr_tb3.ReadOnly = true;
			this.cfr_tb3.Size = new System.Drawing.Size(256, 20);
			this.cfr_tb3.TabIndex = 7;
			this.cfr_tb3.Text = "";
			// 
			// cfr_b3
			// 
			this.cfr_b3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cfr_b3.Location = new System.Drawing.Point(384, 100);
			this.cfr_b3.Name = "cfr_b3";
			this.cfr_b3.Size = new System.Drawing.Size(72, 24);
			this.cfr_b3.TabIndex = 6;
			this.cfr_b3.Text = "Browse...";
			this.cfr_b3.Click += new System.EventHandler(this.cfr_b3_Click);
			// 
			// cfr_l2
			// 
			this.cfr_l2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cfr_l2.Location = new System.Drawing.Point(16, 64);
			this.cfr_l2.Name = "cfr_l2";
			this.cfr_l2.Size = new System.Drawing.Size(96, 16);
			this.cfr_l2.TabIndex = 5;
			this.cfr_l2.Text = "Output AVI File:";
			this.cfr_l2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cfr_tb2
			// 
			this.cfr_tb2.BackColor = System.Drawing.SystemColors.Window;
			this.cfr_tb2.ForeColor = System.Drawing.SystemColors.WindowText;
			this.cfr_tb2.Location = new System.Drawing.Point(112, 62);
			this.cfr_tb2.Name = "cfr_tb2";
			this.cfr_tb2.ReadOnly = true;
			this.cfr_tb2.Size = new System.Drawing.Size(256, 20);
			this.cfr_tb2.TabIndex = 4;
			this.cfr_tb2.Text = "";
			// 
			// cfr_b2
			// 
			this.cfr_b2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cfr_b2.Location = new System.Drawing.Point(384, 60);
			this.cfr_b2.Name = "cfr_b2";
			this.cfr_b2.Size = new System.Drawing.Size(72, 24);
			this.cfr_b2.TabIndex = 3;
			this.cfr_b2.Text = "Browse...";
			this.cfr_b2.Click += new System.EventHandler(this.cfr_b2_Click);
			// 
			// cfr_l1
			// 
			this.cfr_l1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cfr_l1.Location = new System.Drawing.Point(16, 24);
			this.cfr_l1.Name = "cfr_l1";
			this.cfr_l1.Size = new System.Drawing.Size(96, 16);
			this.cfr_l1.TabIndex = 2;
			this.cfr_l1.Text = "Input AVI File:";
			this.cfr_l1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// cfr_tb1
			// 
			this.cfr_tb1.BackColor = System.Drawing.SystemColors.Window;
			this.cfr_tb1.ForeColor = System.Drawing.SystemColors.WindowText;
			this.cfr_tb1.Location = new System.Drawing.Point(112, 22);
			this.cfr_tb1.Name = "cfr_tb1";
			this.cfr_tb1.ReadOnly = true;
			this.cfr_tb1.Size = new System.Drawing.Size(256, 20);
			this.cfr_tb1.TabIndex = 1;
			this.cfr_tb1.Text = "";
			// 
			// cfr_b1
			// 
			this.cfr_b1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.cfr_b1.ForeColor = System.Drawing.SystemColors.ControlText;
			this.cfr_b1.Location = new System.Drawing.Point(384, 20);
			this.cfr_b1.Name = "cfr_b1";
			this.cfr_b1.Size = new System.Drawing.Size(72, 24);
			this.cfr_b1.TabIndex = 0;
			this.cfr_b1.Text = "Browse...";
			this.cfr_b1.Click += new System.EventHandler(this.cfr_b1_Click);
			// 
			// tabPage2
			// 
			this.tabPage2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.tabPage2.Controls.Add(this.tc_cb1);
			this.tabPage2.Controls.Add(this.tc_tb4);
			this.tabPage2.Controls.Add(this.tc_l4);
			this.tabPage2.Controls.Add(this.tc_b4);
			this.tabPage2.Controls.Add(this.tc_l3);
			this.tabPage2.Controls.Add(this.tc_tb3);
			this.tabPage2.Controls.Add(this.tc_b3);
			this.tabPage2.Controls.Add(this.tc_l2);
			this.tabPage2.Controls.Add(this.tc_tb2);
			this.tabPage2.Controls.Add(this.tc_b2);
			this.tabPage2.Controls.Add(this.tc_l1);
			this.tabPage2.Controls.Add(this.tc_tb1);
			this.tabPage2.Controls.Add(this.tc_b1);
			this.tabPage2.Location = new System.Drawing.Point(4, 22);
			this.tabPage2.Name = "tabPage2";
			this.tabPage2.Size = new System.Drawing.Size(480, 182);
			this.tabPage2.TabIndex = 1;
			this.tabPage2.Text = "tc2cfr";
			// 
			// tc_tb4
			// 
			this.tc_tb4.Location = new System.Drawing.Point(112, 146);
			this.tc_tb4.Name = "tc_tb4";
			this.tc_tb4.Size = new System.Drawing.Size(108, 20);
			this.tc_tb4.TabIndex = 21;
			this.tc_tb4.Text = "";
			this.tc_tb4.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tc_l4
			// 
			this.tc_l4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tc_l4.Location = new System.Drawing.Point(16, 148);
			this.tc_l4.Name = "tc_l4";
			this.tc_l4.Size = new System.Drawing.Size(120, 16);
			this.tc_l4.TabIndex = 20;
			this.tc_l4.Text = "Output AVI FPS:";
			// 
			// tc_b4
			// 
			this.tc_b4.Location = new System.Drawing.Point(384, 144);
			this.tc_b4.Name = "tc_b4";
			this.tc_b4.Size = new System.Drawing.Size(72, 24);
			this.tc_b4.TabIndex = 18;
			this.tc_b4.Text = "Run";
			this.tc_b4.Click += new System.EventHandler(this.tc_b4_Click);
			// 
			// tc_l3
			// 
			this.tc_l3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tc_l3.Location = new System.Drawing.Point(16, 104);
			this.tc_l3.Name = "tc_l3";
			this.tc_l3.Size = new System.Drawing.Size(96, 16);
			this.tc_l3.TabIndex = 17;
			this.tc_l3.Text = "Output AVI File:";
			this.tc_l3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// tc_tb3
			// 
			this.tc_tb3.BackColor = System.Drawing.SystemColors.Window;
			this.tc_tb3.Location = new System.Drawing.Point(112, 102);
			this.tc_tb3.Name = "tc_tb3";
			this.tc_tb3.ReadOnly = true;
			this.tc_tb3.Size = new System.Drawing.Size(256, 20);
			this.tc_tb3.TabIndex = 16;
			this.tc_tb3.Text = "";
			// 
			// tc_b3
			// 
			this.tc_b3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tc_b3.Location = new System.Drawing.Point(384, 100);
			this.tc_b3.Name = "tc_b3";
			this.tc_b3.Size = new System.Drawing.Size(72, 24);
			this.tc_b3.TabIndex = 15;
			this.tc_b3.Text = "Browse...";
			this.tc_b3.Click += new System.EventHandler(this.tc_b3_Click);
			// 
			// tc_l2
			// 
			this.tc_l2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tc_l2.Location = new System.Drawing.Point(16, 64);
			this.tc_l2.Name = "tc_l2";
			this.tc_l2.Size = new System.Drawing.Size(96, 16);
			this.tc_l2.TabIndex = 14;
			this.tc_l2.Text = "Input TC File:";
			this.tc_l2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// tc_tb2
			// 
			this.tc_tb2.BackColor = System.Drawing.SystemColors.Window;
			this.tc_tb2.Location = new System.Drawing.Point(112, 62);
			this.tc_tb2.Name = "tc_tb2";
			this.tc_tb2.ReadOnly = true;
			this.tc_tb2.Size = new System.Drawing.Size(256, 20);
			this.tc_tb2.TabIndex = 13;
			this.tc_tb2.Text = "";
			// 
			// tc_b2
			// 
			this.tc_b2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tc_b2.Location = new System.Drawing.Point(384, 60);
			this.tc_b2.Name = "tc_b2";
			this.tc_b2.Size = new System.Drawing.Size(72, 24);
			this.tc_b2.TabIndex = 12;
			this.tc_b2.Text = "Browse...";
			this.tc_b2.Click += new System.EventHandler(this.tc_b2_Click);
			// 
			// tc_l1
			// 
			this.tc_l1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tc_l1.Location = new System.Drawing.Point(16, 24);
			this.tc_l1.Name = "tc_l1";
			this.tc_l1.Size = new System.Drawing.Size(96, 16);
			this.tc_l1.TabIndex = 11;
			this.tc_l1.Text = "Input AVI File:";
			this.tc_l1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// tc_tb1
			// 
			this.tc_tb1.BackColor = System.Drawing.SystemColors.Window;
			this.tc_tb1.ForeColor = System.Drawing.SystemColors.WindowText;
			this.tc_tb1.Location = new System.Drawing.Point(112, 22);
			this.tc_tb1.Name = "tc_tb1";
			this.tc_tb1.ReadOnly = true;
			this.tc_tb1.Size = new System.Drawing.Size(256, 20);
			this.tc_tb1.TabIndex = 10;
			this.tc_tb1.Text = "";
			// 
			// tc_b1
			// 
			this.tc_b1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tc_b1.Location = new System.Drawing.Point(384, 20);
			this.tc_b1.Name = "tc_b1";
			this.tc_b1.Size = new System.Drawing.Size(72, 24);
			this.tc_b1.TabIndex = 9;
			this.tc_b1.Text = "Browse...";
			this.tc_b1.Click += new System.EventHandler(this.tc_b1_Click);
			// 
			// tabPage4
			// 
			this.tabPage4.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.tabPage4.Controls.Add(this.tcc_b3);
			this.tabPage4.Controls.Add(this.tcc_tb3);
			this.tabPage4.Controls.Add(this.tcc_lb4);
			this.tabPage4.Controls.Add(this.tcc_tb5);
			this.tabPage4.Controls.Add(this.tcc_lb6);
			this.tabPage4.Controls.Add(this.tcc_tb4);
			this.tabPage4.Controls.Add(this.tcc_lb5);
			this.tabPage4.Controls.Add(this.tcc_lb3);
			this.tabPage4.Controls.Add(this.tcc_dl1);
			this.tabPage4.Controls.Add(this.tcc_l2);
			this.tabPage4.Controls.Add(this.tcc_tb2);
			this.tabPage4.Controls.Add(this.tcc_b2);
			this.tabPage4.Controls.Add(this.tcc_l1);
			this.tabPage4.Controls.Add(this.tcc_tb1);
			this.tabPage4.Controls.Add(this.tcc_b1);
			this.tabPage4.Location = new System.Drawing.Point(4, 22);
			this.tabPage4.Name = "tabPage4";
			this.tabPage4.Size = new System.Drawing.Size(480, 182);
			this.tabPage4.TabIndex = 3;
			this.tabPage4.Text = "tcConv";
			// 
			// tcc_b3
			// 
			this.tcc_b3.Location = new System.Drawing.Point(384, 144);
			this.tcc_b3.Name = "tcc_b3";
			this.tcc_b3.Size = new System.Drawing.Size(72, 24);
			this.tcc_b3.TabIndex = 29;
			this.tcc_b3.Text = "Run";
			this.tcc_b3.Click += new System.EventHandler(this.tcc_b3_Click);
			// 
			// tcc_tb3
			// 
			this.tcc_tb3.Location = new System.Drawing.Point(80, 146);
			this.tcc_tb3.Name = "tcc_tb3";
			this.tcc_tb3.Size = new System.Drawing.Size(64, 20);
			this.tcc_tb3.TabIndex = 28;
			this.tcc_tb3.Text = "";
			this.tcc_tb3.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tcc_lb4
			// 
			this.tcc_lb4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tcc_lb4.Location = new System.Drawing.Point(16, 148);
			this.tcc_lb4.Name = "tcc_lb4";
			this.tcc_lb4.Size = new System.Drawing.Size(56, 16);
			this.tcc_lb4.TabIndex = 27;
			this.tcc_lb4.Text = "Max Diff:";
			this.tcc_lb4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// tcc_tb5
			// 
			this.tcc_tb5.Location = new System.Drawing.Point(264, 146);
			this.tcc_tb5.Name = "tcc_tb5";
			this.tcc_tb5.Size = new System.Drawing.Size(72, 20);
			this.tcc_tb5.TabIndex = 26;
			this.tcc_tb5.Text = "";
			this.tcc_tb5.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tcc_lb6
			// 
			this.tcc_lb6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tcc_lb6.Location = new System.Drawing.Point(176, 148);
			this.tcc_lb6.Name = "tcc_lb6";
			this.tcc_lb6.Size = new System.Drawing.Size(80, 16);
			this.tcc_lb6.TabIndex = 25;
			this.tcc_lb6.Text = "# of Frames:";
			this.tcc_lb6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// tcc_tb4
			// 
			this.tcc_tb4.Location = new System.Drawing.Point(336, 102);
			this.tcc_tb4.Name = "tcc_tb4";
			this.tcc_tb4.Size = new System.Drawing.Size(120, 20);
			this.tcc_tb4.TabIndex = 24;
			this.tcc_tb4.Text = "";
			this.tcc_tb4.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tcc_lb5
			// 
			this.tcc_lb5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tcc_lb5.Location = new System.Drawing.Point(240, 104);
			this.tcc_lb5.Name = "tcc_lb5";
			this.tcc_lb5.Size = new System.Drawing.Size(88, 16);
			this.tcc_lb5.TabIndex = 23;
			this.tcc_lb5.Text = "Assumed FPS:";
			// 
			// tcc_lb3
			// 
			this.tcc_lb3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tcc_lb3.Location = new System.Drawing.Point(16, 104);
			this.tcc_lb3.Name = "tcc_lb3";
			this.tcc_lb3.Size = new System.Drawing.Size(72, 16);
			this.tcc_lb3.TabIndex = 22;
			this.tcc_lb3.Text = "Conversion:";
			this.tcc_lb3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// tcc_dl1
			// 
			this.tcc_dl1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.tcc_dl1.Items.AddRange(new object[] {
														 "v1 -> v2",
														 "v2 -> v1"});
			this.tcc_dl1.Location = new System.Drawing.Point(114, 102);
			this.tcc_dl1.Name = "tcc_dl1";
			this.tcc_dl1.Size = new System.Drawing.Size(104, 21);
			this.tcc_dl1.TabIndex = 21;
			this.tcc_dl1.SelectedIndexChanged += new System.EventHandler(this.tcc_dl1_SelectedIndexChanged);
			// 
			// tcc_l2
			// 
			this.tcc_l2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tcc_l2.Location = new System.Drawing.Point(16, 64);
			this.tcc_l2.Name = "tcc_l2";
			this.tcc_l2.Size = new System.Drawing.Size(88, 16);
			this.tcc_l2.TabIndex = 20;
			this.tcc_l2.Text = "Output TC File:";
			this.tcc_l2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// tcc_tb2
			// 
			this.tcc_tb2.BackColor = System.Drawing.SystemColors.Window;
			this.tcc_tb2.Location = new System.Drawing.Point(112, 62);
			this.tcc_tb2.Name = "tcc_tb2";
			this.tcc_tb2.ReadOnly = true;
			this.tcc_tb2.Size = new System.Drawing.Size(256, 20);
			this.tcc_tb2.TabIndex = 19;
			this.tcc_tb2.Text = "";
			// 
			// tcc_b2
			// 
			this.tcc_b2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tcc_b2.Location = new System.Drawing.Point(384, 60);
			this.tcc_b2.Name = "tcc_b2";
			this.tcc_b2.Size = new System.Drawing.Size(72, 24);
			this.tcc_b2.TabIndex = 18;
			this.tcc_b2.Text = "Browse...";
			this.tcc_b2.Click += new System.EventHandler(this.tcc_b2_Click);
			// 
			// tcc_l1
			// 
			this.tcc_l1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tcc_l1.Location = new System.Drawing.Point(16, 24);
			this.tcc_l1.Name = "tcc_l1";
			this.tcc_l1.Size = new System.Drawing.Size(88, 16);
			this.tcc_l1.TabIndex = 17;
			this.tcc_l1.Text = "Input TC File:";
			this.tcc_l1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// tcc_tb1
			// 
			this.tcc_tb1.BackColor = System.Drawing.SystemColors.Window;
			this.tcc_tb1.ForeColor = System.Drawing.SystemColors.WindowText;
			this.tcc_tb1.Location = new System.Drawing.Point(112, 22);
			this.tcc_tb1.Name = "tcc_tb1";
			this.tcc_tb1.ReadOnly = true;
			this.tcc_tb1.Size = new System.Drawing.Size(256, 20);
			this.tcc_tb1.TabIndex = 16;
			this.tcc_tb1.Text = "";
			// 
			// tcc_b1
			// 
			this.tcc_b1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tcc_b1.Location = new System.Drawing.Point(384, 20);
			this.tcc_b1.Name = "tcc_b1";
			this.tcc_b1.Size = new System.Drawing.Size(72, 24);
			this.tcc_b1.TabIndex = 15;
			this.tcc_b1.Text = "Browse...";
			this.tcc_b1.Click += new System.EventHandler(this.tcc_b1_Click);
			// 
			// tabPage3
			// 
			this.tabPage3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.tabPage3.Controls.Add(this.ep_lb4);
			this.tabPage3.Controls.Add(this.ep_tb3);
			this.tabPage3.Controls.Add(this.ep_b3);
			this.tabPage3.Controls.Add(this.ep_lb1);
			this.tabPage3.Controls.Add(this.ep_lb3);
			this.tabPage3.Controls.Add(this.ep_tb2);
			this.tabPage3.Controls.Add(this.ep_b2);
			this.tabPage3.Controls.Add(this.ep_lb2);
			this.tabPage3.Controls.Add(this.ep_tb1);
			this.tabPage3.Controls.Add(this.ep_b1);
			this.tabPage3.Location = new System.Drawing.Point(4, 22);
			this.tabPage3.Name = "tabPage3";
			this.tabPage3.Size = new System.Drawing.Size(480, 182);
			this.tabPage3.TabIndex = 2;
			this.tabPage3.Text = "Executable Paths";
			// 
			// ep_lb4
			// 
			this.ep_lb4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ep_lb4.Location = new System.Drawing.Point(8, 146);
			this.ep_lb4.Name = "ep_lb4";
			this.ep_lb4.Size = new System.Drawing.Size(80, 16);
			this.ep_lb4.TabIndex = 24;
			this.ep_lb4.Text = "tcConv Path:";
			this.ep_lb4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// ep_tb3
			// 
			this.ep_tb3.BackColor = System.Drawing.SystemColors.Window;
			this.ep_tb3.Location = new System.Drawing.Point(96, 144);
			this.ep_tb3.Name = "ep_tb3";
			this.ep_tb3.ReadOnly = true;
			this.ep_tb3.Size = new System.Drawing.Size(272, 20);
			this.ep_tb3.TabIndex = 23;
			this.ep_tb3.Text = "";
			// 
			// ep_b3
			// 
			this.ep_b3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ep_b3.Location = new System.Drawing.Point(386, 142);
			this.ep_b3.Name = "ep_b3";
			this.ep_b3.Size = new System.Drawing.Size(72, 24);
			this.ep_b3.TabIndex = 22;
			this.ep_b3.Text = "Browse...";
			this.ep_b3.Click += new System.EventHandler(this.ep_b3_Click);
			// 
			// ep_lb1
			// 
			this.ep_lb1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ep_lb1.Location = new System.Drawing.Point(46, 16);
			this.ep_lb1.Name = "ep_lb1";
			this.ep_lb1.Size = new System.Drawing.Size(384, 40);
			this.ep_lb1.TabIndex = 21;
			this.ep_lb1.Text = "If the cfr2tc, tc2cfr, or tcConv executable is not located in the same directory " +
				"as tc-GUI then you will need to set the correct path below.";
			this.ep_lb1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// ep_lb3
			// 
			this.ep_lb3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ep_lb3.Location = new System.Drawing.Point(18, 110);
			this.ep_lb3.Name = "ep_lb3";
			this.ep_lb3.Size = new System.Drawing.Size(70, 16);
			this.ep_lb3.TabIndex = 20;
			this.ep_lb3.Text = "tc2cfr Path:";
			this.ep_lb3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// ep_tb2
			// 
			this.ep_tb2.BackColor = System.Drawing.SystemColors.Window;
			this.ep_tb2.Location = new System.Drawing.Point(96, 108);
			this.ep_tb2.Name = "ep_tb2";
			this.ep_tb2.ReadOnly = true;
			this.ep_tb2.Size = new System.Drawing.Size(272, 20);
			this.ep_tb2.TabIndex = 19;
			this.ep_tb2.Text = "";
			// 
			// ep_b2
			// 
			this.ep_b2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ep_b2.Location = new System.Drawing.Point(386, 106);
			this.ep_b2.Name = "ep_b2";
			this.ep_b2.Size = new System.Drawing.Size(72, 24);
			this.ep_b2.TabIndex = 18;
			this.ep_b2.Text = "Browse...";
			this.ep_b2.Click += new System.EventHandler(this.ep_b2_Click);
			// 
			// ep_lb2
			// 
			this.ep_lb2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ep_lb2.Location = new System.Drawing.Point(18, 74);
			this.ep_lb2.Name = "ep_lb2";
			this.ep_lb2.Size = new System.Drawing.Size(70, 16);
			this.ep_lb2.TabIndex = 17;
			this.ep_lb2.Text = "cfr2tc Path:";
			this.ep_lb2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// ep_tb1
			// 
			this.ep_tb1.BackColor = System.Drawing.SystemColors.Window;
			this.ep_tb1.Location = new System.Drawing.Point(96, 72);
			this.ep_tb1.Name = "ep_tb1";
			this.ep_tb1.ReadOnly = true;
			this.ep_tb1.Size = new System.Drawing.Size(272, 20);
			this.ep_tb1.TabIndex = 16;
			this.ep_tb1.Text = "";
			// 
			// ep_b1
			// 
			this.ep_b1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ep_b1.Location = new System.Drawing.Point(386, 70);
			this.ep_b1.Name = "ep_b1";
			this.ep_b1.Size = new System.Drawing.Size(72, 24);
			this.ep_b1.TabIndex = 15;
			this.ep_b1.Text = "Browse...";
			this.ep_b1.Click += new System.EventHandler(this.ep_b1_Click);
			// 
			// tc_cb1
			// 
			this.tc_cb1.Location = new System.Drawing.Point(254, 143);
			this.tc_cb1.Name = "tc_cb1";
			this.tc_cb1.Size = new System.Drawing.Size(114, 27);
			this.tc_cb1.TabIndex = 22;
			this.tc_cb1.Text = "Input FPS instead of TC File";
			this.tc_cb1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.tc_cb1.CheckedChanged += new System.EventHandler(this.tc_cb1_CheckedChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(488, 189);
			this.Controls.Add(this.tabControl1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "tc-GUI  v1.2";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.tabControl1.ResumeLayout(false);
			this.tabPage1.ResumeLayout(false);
			this.tabPage2.ResumeLayout(false);
			this.tabPage4.ResumeLayout(false);
			this.tabPage3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			cfr_tb1.Text = "";
			cfr_tb2.Text = "";
			cfr_tb3.Text = "";
			cfr_dl1.SelectedIndex = 0;
			tc_tb1.Text = "";
			tc_tb2.Text = "";
			tc_tb3.Text = "";
			tc_tb4.Text = "120000/1001";
			tc_cb1.Checked = false;
			tcc_tb1.Text = "";
			tcc_tb2.Text = "";
			tcc_tb3.Text = "0.1";
			tcc_tb4.Text = "30000/1001";
			tcc_tb5.Text = "";
			tcc_dl1.SelectedIndex = 0;
			cfr_path = Application.StartupPath + "\\cfr2tc.exe";
			tc_path = Application.StartupPath + "\\tc2cfr.exe";
			tcc_path = Application.StartupPath + "\\tcConv.exe";
			ep_tb1.Text = cfr_path;
			ep_tb2.Text = tc_path;
			ep_tb3.Text = tcc_path;
			this.Closing += new CancelEventHandler(Form1_Closing);
			System.Reflection.Assembly p = 
				System.Reflection.Assembly.GetExecutingAssembly();
			Stream s = p.GetManifestResourceStream("tc_GUI.fmp.bmp");
			Bitmap bmp = new Bitmap(s);
			Icon ic = Icon.FromHandle(bmp.GetHicon());
			this.Icon = ic;
		}

		private void tc_cb1_CheckedChanged(object sender, System.EventArgs e)
		{
			tc_tb2.Text = "";
			if (tc_cb1.Checked)
			{
				tc_b2.Enabled = false;
				tc_b2.Visible = false;
				tc_l2.Text = "Input FPS:";
				tc_tb2.ReadOnly = false;
				tc_tb2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			}
			else
			{
				tc_b2.Enabled = true;
				tc_b2.Visible = true;
				tc_l2.Text = "Input TC File:";
				tc_tb2.ReadOnly = true;
				tc_tb2.TextAlign = System.Windows.Forms.HorizontalAlignment.Left;
			}
		}

		private void tc_b1_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fDialog = new OpenFileDialog();
			fDialog.Title = "Select Input AVI File";
			fDialog.Filter = "AVI Files (*.avi)|*.avi";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "avi";
			if (fDialog.ShowDialog() == DialogResult.OK)
				tc_tb1.Text = fDialog.FileName.ToString();
		}

		private void tc_b2_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fDialog = new OpenFileDialog();
			fDialog.Title = "Select Input Timecode File";
			fDialog.Filter = "Timecode File (*.txt)|*.txt";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "txt";
			if (fDialog.ShowDialog() == DialogResult.OK)
				tc_tb2.Text = fDialog.FileName.ToString();
		}

		private void tc_b3_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog fDialog = new SaveFileDialog();
			fDialog.Title = "Set Output AVI File";
			fDialog.Filter = "AVI Files (*.avi)|*.avi";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "avi";
			if (fDialog.ShowDialog() == DialogResult.OK)
				tc_tb3.Text = fDialog.FileName.ToString();
		}

		private void tc_b4_Click(object sender, System.EventArgs e)
		{
			if (tc_running) return;
			if (tc_tb1.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an input avi file name/path.","tc-GUI Error",
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			if (tc_tb2.Text.CompareTo("") == 0)
			{
				if (tc_cb1.Checked)
				{
					MessageBox.Show("You must specify an input fps value.","tc-GUI Error",
						MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				else
				{
					MessageBox.Show("You must specify an input timecode file name/path.","tc-GUI Error",
						MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
				return;
			}
			if (tc_tb3.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an output avi file name/path.","tc-GUI Error",
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			if (tc_tb4.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an output avi file fps value.","tc-GUI Error",
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			if (tc_cb1.Checked)
			{
				double ifps = 0.0;
				bool iferror = false;
				try
				{
					ifps = System.Double.Parse(tc_tb2.Text.ToString());
				}
				catch (System.FormatException) { iferror = true; }
				catch (System.OverflowException) { iferror = true; }
				catch (System.ArgumentNullException) { iferror = true; }
				if (ifps <= 0.0) iferror = true;
				if (iferror)
				{
					int pos = tc_tb2.Text.IndexOf("/");
					if (pos != -1)
					{
						string num = "", den = "";
						try 
						{
							num = tc_tb2.Text.Substring(0,pos);
							den = tc_tb2.Text.Substring(pos+1,tc_tb2.Text.Length-pos-1);
							iferror = false;
						}
						catch(System.ArgumentOutOfRangeException) { }
						if (!iferror)
						{
							UInt32 numi = 0, deni = 0;
							try 
							{
								numi = UInt32.Parse(num);
								deni = UInt32.Parse(den);
							}
							catch (System.FormatException) { iferror = true; }
							catch (System.OverflowException) { iferror = true; }
							catch (System.ArgumentNullException) { iferror = true; }
							if (numi == 0 || deni == 0) iferror = true;
						}
						if (iferror)
						{
							string fpsError = "Invalid value for Input FPS." +
								" Please enter a valid (positive) num/den fraction.";
							MessageBox.Show(fpsError, "tc-GUI Error", MessageBoxButtons.OK, 
								MessageBoxIcon.Error);
							return;
						}
					}
					else
					{
						string fpsError = "Invalid value for Input FPS." +
							" Please enter a valid (positive) floating point number.";
						MessageBox.Show(fpsError, "tc-GUI Error", MessageBoxButtons.OK, 
							MessageBoxIcon.Error);
						return;
					}
				}
			}
			double fps = 0.0;
			bool ferror = false;
			try
			{
				fps = System.Double.Parse(tc_tb4.Text.ToString());
			}
			catch (System.FormatException) { ferror = true; }
			catch (System.OverflowException) { ferror = true; }
			catch (System.ArgumentNullException) { ferror = true; }
			if (fps <= 0.0) ferror = true;
			if (ferror)
			{
				int pos = tc_tb4.Text.IndexOf("/");
				if (pos != -1)
				{
					string num = "", den = "";
					try 
					{
						num = tc_tb4.Text.Substring(0,pos);
						den = tc_tb4.Text.Substring(pos+1,tc_tb4.Text.Length-pos-1);
						ferror = false;
					}
					catch(System.ArgumentOutOfRangeException) { }
					if (!ferror)
					{
						UInt32 numi = 0, deni = 0;
						try 
						{
							numi = UInt32.Parse(num);
							deni = UInt32.Parse(den);
						}
						catch (System.FormatException) { ferror = true; }
						catch (System.OverflowException) { ferror = true; }
						catch (System.ArgumentNullException) { ferror = true; }
						if (numi == 0 || deni == 0) ferror = true;
					}
					if (ferror)
					{
						string fpsError = "Invalid value for Output AVI File FPS." +
							" Please enter a valid (positive) num/den fraction.";
						MessageBox.Show(fpsError, "tc-GUI Error", MessageBoxButtons.OK, 
							MessageBoxIcon.Error);
						return;
					}
				}
				else
				{
					string fpsError = "Invalid value for Output AVI File FPS." +
						" Please enter a valid (positive) floating point number.";
					MessageBox.Show(fpsError, "tc-GUI Error", MessageBoxButtons.OK, 
						MessageBoxIcon.Error);
					return;
				}
			}
			tc_running = true;
			tc_b4.Enabled = false;
			psInfo_tc.FileName = tc_path;
			if (!File.Exists(psInfo_tc.FileName))
			{
				MessageBox.Show("tc2cfr executable not found. " + 
					"Please set the correct path in the Executable Paths tab.", 
					"tc-GUI Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				tc_b4.Enabled = true;
				tc_running = false;
				return;
			}
			psInfo_tc.ErrorDialog = true;
			psInfo_tc.Arguments = "\""+tc_tb4.Text.ToString()+"\"";
			psInfo_tc.Arguments += " \""+tc_tb1.Text.ToString()+"\"";
			psInfo_tc.Arguments += " \""+tc_tb2.Text.ToString()+"\"";
			psInfo_tc.Arguments += " \""+tc_tb3.Text.ToString()+"\"";
			psInfo_tc.UseShellExecute = false;
			psInfo_tc.RedirectStandardOutput = true;
			psInfo_tc.CreateNoWindow = true;
			Thread nthread = new Thread(new ThreadStart(run_tc_process));
			nthread.Start();
		}

		private void run_tc_process()
		{
			Form2 f2 = new Form2();
			f2.Show();
			f2.start_process(psInfo_tc, 2);
			tc_b4.Enabled = true;
			tc_running = false;
		}

		private void cfr_b1_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fDialog = new OpenFileDialog();
			fDialog.Title = "Select Input AVI File";
			fDialog.Filter = "AVI Files (*.avi)|*.avi";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "avi";
			if (fDialog.ShowDialog() == DialogResult.OK)
				cfr_tb1.Text = fDialog.FileName.ToString();
		}

		private void cfr_b2_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog fDialog = new SaveFileDialog();
			if (cfr_dl1.SelectedIndex < 2)
			{
				fDialog.Title = "Set Output AVI File";
				fDialog.Filter = "AVI Files (*.avi)|*.avi";
				fDialog.AddExtension = true;
				fDialog.DefaultExt = "avi";
			}
			else
			{
				fDialog.Title = "Set Output AVS File";
				fDialog.Filter = "AVS Files (*.avs)|*.avs";
				fDialog.AddExtension = true;
				fDialog.DefaultExt = "avs";
			}
			if (fDialog.ShowDialog() == DialogResult.OK)
				cfr_tb2.Text = fDialog.FileName.ToString();
		}

		private void cfr_b3_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog fDialog = new SaveFileDialog();
			fDialog.Title = "Set Output Timecode File";
			fDialog.Filter = "Timecode File (*.txt)|*.txt";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "txt";
			if (fDialog.ShowDialog() == DialogResult.OK)
				cfr_tb3.Text = fDialog.FileName.ToString();
		}

		private void cfr_dl1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (cfr_dl1.SelectedIndex == 0 || cfr_dl1.SelectedIndex == 1)
			{
				cfr_tb2.Enabled = true;
				cfr_b2.Enabled = true;
				cfr_l2.Enabled = true;
				if (cfr_l2.Text == "Output AVS File:")
				{
					cfr_l2.Text = "Output AVI File:";
					cfr_tb2.Text = "";
				}
			}
			else if (cfr_dl1.SelectedIndex == 2 || cfr_dl1.SelectedIndex == 3)
			{
				cfr_tb2.Enabled = false;
				cfr_b2.Enabled = false;
				cfr_l2.Enabled = false;
			}
			else
			{
				cfr_tb2.Enabled = true;
				cfr_b2.Enabled = true;
				cfr_l2.Enabled = true;
				if (cfr_l2.Text == "Output AVI File:")
				{
					cfr_l2.Text = "Output AVS File:";
					cfr_tb2.Text = "";
				}
			}
		}

		private void cfr_b4_Click(object sender, System.EventArgs e)
		{
			if (cfr_running) return;
			if (cfr_tb1.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an input avi file name and path.",
					"tc-GUI Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			if ((cfr_dl1.SelectedIndex == 0 || cfr_dl1.SelectedIndex == 1) && 
				cfr_tb2.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an output avi file name and path.", 
					"tc-GUI Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			else if ((cfr_dl1.SelectedIndex == 4 || cfr_dl1.SelectedIndex == 5) && 
				cfr_tb2.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an output avs file name and path.", 
					"tc-GUI Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			if (cfr_tb3.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an output timecode file name and path.",
					"tc-GUI Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			cfr_running = true;
			cfr_b4.Enabled = false;
			psInfo_cfr.FileName = cfr_path;
			if (!File.Exists(psInfo_cfr.FileName))
			{
				MessageBox.Show("cfr2tc executable not found. " + 
					"Please set the correct path in the Executable Paths tab.", 
					"tc-GUI Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				cfr_b4.Enabled = true;
				cfr_running = false;
				return;
			}
			psInfo_cfr.ErrorDialog = true;
			psInfo_cfr.Arguments = "\""+cfr_tb1.Text.ToString()+"\"";
			if (!(cfr_dl1.SelectedIndex == 2 || cfr_dl1.SelectedIndex == 3)) 
				psInfo_cfr.Arguments += " \""+cfr_tb2.Text.ToString()+"\"";
			else psInfo_cfr.Arguments += " \"unused.avi\"";
			psInfo_cfr.Arguments += " \""+cfr_tb3.Text.ToString()+"\"";
			int mode = cfr_dl1.SelectedIndex+1;
			psInfo_cfr.Arguments += " \""+mode.ToString()+"\"";
			psInfo_cfr.UseShellExecute = false;
			psInfo_cfr.RedirectStandardOutput = true;
			psInfo_cfr.CreateNoWindow = true;
			Thread nthread = new Thread(new ThreadStart(run_cfr_process));
			nthread.Start();
		}

		private void run_cfr_process()
		{
			Form2 f2 = new Form2();
			f2.Show();
			f2.start_process(psInfo_cfr, 1);
			cfr_b4.Enabled = true;
			cfr_running = false;
		}

		private void tcc_b1_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fDialog = new OpenFileDialog();
			fDialog.Title = "Select Input Timecode File";
			fDialog.Filter = "Timecode File (*.txt)|*.txt";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "txt";
			if (fDialog.ShowDialog() == DialogResult.OK)
				tcc_tb1.Text = fDialog.FileName.ToString();
		}

		private void tcc_b2_Click(object sender, System.EventArgs e)
		{
			SaveFileDialog fDialog = new SaveFileDialog();
			fDialog.Title = "Set Output Timecode File";
			fDialog.Filter = "Timecode File (*.txt)|*.txt";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "txt";
			if (fDialog.ShowDialog() == DialogResult.OK)
				tcc_tb2.Text = fDialog.FileName.ToString();
		}

		private void tcc_dl1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (tcc_dl1.SelectedIndex == 0)
			{
				tcc_lb4.Enabled = false;
				tcc_lb5.Enabled = false;
				tcc_tb3.Enabled = false;
				tcc_tb4.Enabled = false;
				tcc_lb6.Enabled = true;
				tcc_tb5.Enabled = true;
			}
			else
			{
				tcc_lb4.Enabled = true;
				tcc_lb5.Enabled = true;
				tcc_tb3.Enabled = true;
				tcc_tb4.Enabled = true;
				tcc_lb6.Enabled = false;
				tcc_tb5.Enabled = false;
			}
		}

		private void tcc_b3_Click(object sender, System.EventArgs e)
		{
			if (tcc_running) return;
			if (tcc_tb1.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an input timecode file name/path.","tc-GUI Error",
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			if (tcc_tb2.Text.CompareTo("") == 0)
			{
				MessageBox.Show("You must specify an output timecode file name/path.","tc-GUI Error",
					MessageBoxButtons.OK, MessageBoxIcon.Error);
				return;
			}
			psInfo_tcc.Arguments = "\""+tcc_tb1.Text.ToString()+"\"";
			psInfo_tcc.Arguments += " \""+tcc_tb2.Text.ToString()+"\"";
			if (tcc_dl1.SelectedIndex == 1) // v2 -> v1 (assume_fps + max_diff)
			{
				double fps = 0.0;
				bool ferror = false;
				try
				{
					fps = System.Double.Parse(tcc_tb4.Text.ToString());
				}
				catch (System.FormatException) { ferror = true; }
				catch (System.OverflowException) { ferror = true; }
				catch (System.ArgumentNullException) { ferror = true; }
				if (fps <= 0.0) ferror = true;
				if (ferror)
				{
					int pos = tcc_tb4.Text.IndexOf("/");
					if (pos != -1)
					{
						string num = "", den = "";
						try 
						{
							num = tcc_tb4.Text.Substring(0,pos);
							den = tcc_tb4.Text.Substring(pos+1,tcc_tb4.Text.Length-pos-1);
							ferror = false;
						}
						catch(System.ArgumentOutOfRangeException) { }
						if (!ferror)
						{
							UInt32 numi = 0, deni = 0;
							try 
							{
								numi = UInt32.Parse(num);
								deni = UInt32.Parse(den);
							}
							catch (System.FormatException) { ferror = true; }
							catch (System.OverflowException) { ferror = true; }
							catch (System.ArgumentNullException) { ferror = true; }
							if (numi == 0 || deni == 0) ferror = true;
						}
						if (ferror)
						{
							string fpsError = "Invalid value for Assumed FPS." +
								" Please enter a valid (positive) num/den fraction.";
							MessageBox.Show(fpsError, "tc-GUI Error", MessageBoxButtons.OK, 
								MessageBoxIcon.Error);
							return;
						}
					}
					else
					{
						string fpsError = "Invalid value for Assumed FPS." +
							" Please enter a valid (positive) floating point number.";
						MessageBox.Show(fpsError, "tc-GUI Error", MessageBoxButtons.OK, 
							MessageBoxIcon.Error);
						return;
					}
				}
				double max_diff = 0.0;
				bool ferror2 = false;
				try
				{
					max_diff = System.Double.Parse(tcc_tb3.Text.ToString());
				}
				catch (System.FormatException) { ferror2 = true; }
				catch (System.OverflowException) { ferror2 = true; }
				catch (System.ArgumentNullException) { ferror2 = true; }
				if (max_diff <= 0.0) ferror2 = true;
				if (ferror2)
				{
					string maxdError = "Invalid value for Max Diff." +
						" Please enter a valid (positive) floating point number.";
					MessageBox.Show(maxdError, "tc-GUI Error", MessageBoxButtons.OK, 
						MessageBoxIcon.Error);
					return;
				}
				psInfo_tcc.Arguments += " \""+tcc_tb4.Text.ToString()+"\"";
				psInfo_tcc.Arguments += " \""+tcc_tb3.Text.ToString()+"\"";
			}
			else // v1 -> v2 (num_frames)
			{
				int num_frames = 0;
				bool ierror = false;
				try
				{
					num_frames = System.Int32.Parse(tcc_tb5.Text.ToString());
				}
				catch (System.FormatException) { ierror = true; }
				catch (System.OverflowException) { ierror = true; }
				catch (System.ArgumentNullException) { ierror = true; }
				if (num_frames <= 0) ierror = true;
				if (ierror)
				{
					string nfError = "Invalid value for # of Frames." +
						" Please enter a valid (positive) integer number.";
					MessageBox.Show(nfError, "tc-GUI Error", MessageBoxButtons.OK, 
						MessageBoxIcon.Error);
					return;
				}
				psInfo_tcc.Arguments += " \""+tcc_tb5.Text.ToString()+"\"";
			}
			tcc_running = true;
			tcc_b3.Enabled = false;
			psInfo_tcc.FileName = tcc_path;
			if (!File.Exists(psInfo_tcc.FileName))
			{
				MessageBox.Show("tcConv executable not found. " + 
					"Please set the correct path in the Executable Paths tab.", 
					"tc-GUI Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				tcc_b3.Enabled = true;
				tcc_running = false;
				return;
			}
			psInfo_tcc.ErrorDialog = true;
			psInfo_tcc.UseShellExecute = false;
			psInfo_tcc.RedirectStandardOutput = true;
			psInfo_tcc.CreateNoWindow = true;
			Thread nthread = new Thread(new ThreadStart(run_tcc_process));
			nthread.Start();
		}

		private void run_tcc_process()
		{
			Form2 f2 = new Form2();
			f2.Show();
			f2.start_process(psInfo_tcc, 1);
			tcc_b3.Enabled = true;
			tcc_running = false;
		}

		private void ep_b1_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fDialog = new OpenFileDialog();
			fDialog.Title = "Select cfr2tc Executable";
			fDialog.Filter = "Executables (*.exe)|*.exe";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "exe";
			if (fDialog.ShowDialog() == DialogResult.OK)
			{
				ep_tb1.Text = fDialog.FileName.ToString();
				cfr_path = fDialog.FileName.ToString();
			}
		}

		private void ep_b2_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fDialog = new OpenFileDialog();
			fDialog.Title = "Select tc2cfr Executable";
			fDialog.Filter = "Executables (*.exe)|*.exe";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "exe";
			if (fDialog.ShowDialog() == DialogResult.OK)
			{
				ep_tb2.Text = fDialog.FileName.ToString();
				tc_path = fDialog.FileName.ToString();
			}
		}

		private void ep_b3_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog fDialog = new OpenFileDialog();
			fDialog.Title = "Select tcConv Executable";
			fDialog.Filter = "Executables (*.exe)|*.exe";
			fDialog.AddExtension = true;
			fDialog.DefaultExt = "exe";
			if (fDialog.ShowDialog() == DialogResult.OK)
			{
				ep_tb3.Text = fDialog.FileName.ToString();
				tcc_path = fDialog.FileName.ToString();
			}
		}

		private void Form1_Closing(object sender, CancelEventArgs e)
		{
			if (cfr_running || tc_running || tcc_running)
			{
				MessageBox.Show("Cannot exit gui while a process is executing.",
					"tc-GUI Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				e.Cancel = true;
			}
		}
	}
}