/*
**                   tc-GUI v1.2 - August 02, 2006
**
**   This program is a GUI frontend for the commandline programs cfr2tc,
**   tc2cfr, and tcConv.
**   
**   Copyright (C) 2005-2006 Kevin Stone
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.Threading;
using System.Resources;

namespace tc_GUI
{
	/// <summary>
	/// Summary description for Form2.
	/// </summary>
	public class Form2 : System.Windows.Forms.Form
	{
		bool running = false;
		private ProcessStartInfo psInfo;

		private System.Windows.Forms.Button f2_b1;
		public System.Windows.Forms.ListBox f2_lb1;
		private System.Windows.Forms.Label f2_l1;
		private System.Windows.Forms.Label f2_l2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form2()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.f2_b1 = new System.Windows.Forms.Button();
			this.f2_lb1 = new System.Windows.Forms.ListBox();
			this.f2_l1 = new System.Windows.Forms.Label();
			this.f2_l2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// f2_b1
			// 
			this.f2_b1.Location = new System.Drawing.Point(256, 232);
			this.f2_b1.Name = "f2_b1";
			this.f2_b1.Size = new System.Drawing.Size(72, 24);
			this.f2_b1.TabIndex = 1;
			this.f2_b1.Text = "OK";
			this.f2_b1.Click += new System.EventHandler(this.f2_b1_Click);
			// 
			// f2_lb1
			// 
			this.f2_lb1.Location = new System.Drawing.Point(16, 88);
			this.f2_lb1.Name = "f2_lb1";
			this.f2_lb1.SelectionMode = System.Windows.Forms.SelectionMode.None;
			this.f2_lb1.Size = new System.Drawing.Size(312, 134);
			this.f2_lb1.TabIndex = 2;
			// 
			// f2_l1
			// 
			this.f2_l1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.f2_l1.Location = new System.Drawing.Point(16, 8);
			this.f2_l1.Name = "f2_l1";
			this.f2_l1.Size = new System.Drawing.Size(296, 48);
			this.f2_l1.TabIndex = 3;
			this.f2_l1.Text = "Process Running...";
			// 
			// f2_l2
			// 
			this.f2_l2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.f2_l2.Location = new System.Drawing.Point(16, 64);
			this.f2_l2.Name = "f2_l2";
			this.f2_l2.Size = new System.Drawing.Size(88, 16);
			this.f2_l2.TabIndex = 4;
			this.f2_l2.Text = "CLI Output:";
			// 
			// Form2
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(342, 260);
			this.Controls.Add(this.f2_l2);
			this.Controls.Add(this.f2_l1);
			this.Controls.Add(this.f2_lb1);
			this.Controls.Add(this.f2_b1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.Name = "Form2";
			this.Text = "Form2";
			this.Load += new System.EventHandler(this.Form2_Load);
			this.ResumeLayout(false);

		}
		#endregion

		public void start_process(ProcessStartInfo psInfoIn, int num)
		{
			if (num == 1) this.Text = "cfr2tc Processing";
			else this.Text = "tc2cfr Processing";
			psInfo = psInfoIn;
			Thread nthread = new Thread(new ThreadStart(run_process));
			nthread.Start();
			Application.Run(this);
			nthread.Join();
		}

		private void run_process()
		{
			Process proc = Process.Start(psInfo);
			StreamReader sr = proc.StandardOutput;
			char[] text = new char[256];
			int c = 20, i = 0, k = 0, j = 0;
			while (true)
			{
				c = sr.Read();
				if (c == -1) break;
				else if (c == 13) // carriage return
				{
					if (k > 0 && i > 0 && (((j&15) == 0 && j > 0) || sr.Peek() == 10))
					{
						f2_lb1.Items.RemoveAt(k-1);
						f2_lb1.Items.Insert(k-1, new String(text,0,i));
					}
					++j;
					i = 0;
				}
				else if (c == 10) // newline feed
				{
					f2_lb1.Items.Insert(k++, new String(text,0,i));
					i = 0;
				}
				else text[i++] = (char)c;
			}
			proc.WaitForExit();
			int exit_code = proc.ExitCode;
			if (exit_code == 0) f2_l1.Text += "\nProcessing Completed." +
					"\nExit Code (0):  Everything went fine.";
			else f2_l1.Text += "\nProcessing Incomplete." + 
					 "\nExit Code (" + exit_code.ToString() + "):  A problem was encountered.";
			running = false;
			f2_b1.Enabled = true;
		}

		private void f2_b1_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void Form2_Load(object sender, System.EventArgs e)
		{
			f2_b1.Enabled = false;
			running = true;
			System.Reflection.Assembly p = 
				System.Reflection.Assembly.GetExecutingAssembly();
			Stream s = p.GetManifestResourceStream("tc_GUI.fmp.bmp");
			Bitmap bmp = new Bitmap(s);
			Icon ic = Icon.FromHandle(bmp.GetHicon());
			this.Icon = ic;
			this.Closing += new CancelEventHandler(Form2_Closing);
		}

		private void Form2_Closing(object sender, CancelEventArgs e)
		{
			if (running) 
				e.Cancel = true;
		}
	}
}